//============================================================================
//	apci8133w.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1999/05/27
//
//============================================================================

unit apci8133w;

interface

uses
	Windows;

//-------------------------------------
// װޒ萔
//-------------------------------------
const
	APCI8133_SUCCESS	      = 0;  // I
	APCI8133_ERR_SYSTEM	      = 1;  // GetLastError sĂ
	APCI8133_ERR_NO_DEVICE	      = 2;  // gp\޲Ȃ
	APCI8133_ERR_IN_USE	      = 3;  // w肳ꂽ޲͎gp
	APCI8133_ERR_INVALID_SLOT     = 4;  // Ș_ۯĔԍw肵
	APCI8133_ERR_RESOURCE	      = 5;  // ؿװ
	APCI8133_ERR_INVALID_PORT     = 6;  // ȃ|[gv
	APCI8133_ERR_INVALID_ARGUMENT = 7;  // Ȉv
	APCI8133_ERR_NO_CREATE	      = 8;  // ޲شĂĂ܂
	APCI8133_ERR_WRAPDLL 	      = DWord(-1);  // ׯ߰֐װ
//-------------------------------------
// ߰Ĕԍ萔
//-------------------------------------
	APCI8133_PORT_1 = 0;
	APCI8133_PORT_2 = 1;
	APCI8133_PORT_3 = 2;
	APCI8133_PORT_4 = 3;
        APCI8133_PORT_5 = 4;
        APCI8133_PORT_6 = 5;
        APCI8133_PORT_7 = 6;
        APCI8133_PORT_8 = 7;
//-------------------------------------
// ̑萔
//-------------------------------------
	APCI8133_DLL_NAME 	= 'apci8133.dll'; // DLĻٖ
	APCI8133_MAX_PORTS	= 8;		  // ߰Đ
	APCI8133_MAX_SLOTS	= 16;		  // őۯĐ
	APCI8133_DEVICE_ID	= $136c8133;	  // ޲ID
	APCI8133_SLOT_AUTO	= $ffff;	  // AutoSlotl
//-------------------------------------
// ؿ\
//-------------------------------------
	APCI8133_MAX_MEM	= 9;
	APCI8133_MAX_IO		= 20;
	APCI8133_MAX_DMA	= 7;

type
	TAPCI8133RESOURCE = record
		dwNumMemWindows:                                 DWORD;	// س޳(gp)
		dwMemBase:	array [1 .. APCI8133_MAX_MEM] of DWORD;	// س޳ްڽ(gp)
		dwMemLength:	array [1 .. APCI8133_MAX_MEM] of DWORD;	// س޳(gp)
		dwMemAttrib:	array [1 .. APCI8133_MAX_MEM] of DWORD;	// س޳(gp)
		dwNumIOPorts:					 DWORD;	// I/O߰Đ
		dwIOPortBase:	array [1 .. APCI8133_MAX_IO] of	 DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. APCI8133_MAX_IO] of	 DWORD;	// I/O߰Ē
		dwNumDMAs:					 DWORD;	// DMAِ(gp)
		dwDMALst:	array [1 .. APCI8133_MAX_DMA] of DWORD;	// DMAؽ(gp)
		dwDMAAttrib:	array [1 .. APCI8133_MAX_DMA] of DWORD;	// DMAّؽ(gp)
		dwReserved1:	array [1 .. 3] of		 DWORD;	// \(gp)
	end;
//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Apci8133wDllOpen: Boolean;
// DLL ۰
function Apci8133wDllClose: Boolean;
// aPCI-8133 DLL,޲ײްްޮݔԍ擾
function Apci8133wGetVersion(var pdwDllVersion:DWord; var pdwDriverVersion:DWord): Boolean;
// CӂaPCI-8133̎gp錾
function Apci8133wCreate(var pwLogSlot:Word): Boolean;
// CӂaPCI-8133̎gpJ
function Apci8133wClose(wLogSlot:Word): Boolean;
// ؿ擾
function Apci8133wGetResource(wLogSlot:Word; var pResInfo:TAPCI8133RESOURCE): Boolean;
// Cӂ߰Ăްo
function Apci8133wOutPort(wLogSlot:Word; dwLogPort:DWord; bOutValue:Byte): Boolean;
// aPCI-8133̴װ
function Apci8133wGetLastError(wLogSlot:Word): DWord;
// ۰ذ̒l擾
function Apci8133wGetSwitchValue(wLogSlot:Word; var pdwSwitchValue:DWord): Boolean;

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;

type
	TApci8133GetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): BOOL; stdcall;
	TApci8133Create = function(var pwLogSlot:Word): BOOL; stdcall;
	TApci8133Close = function(wLogSlot:WORD): BOOL; stdcall;
	TApci8133GetResource = function(wLogSlot:WORD; var pres:TAPCI8133RESOURCE): BOOL; stdcall;
	TApci8133OutPort = function(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): BOOL; stdcall;
	TApci8133GetLastError = function(wLogSlot:WORD): DWORD; stdcall;
	TApci8133GetSwitchValue = function(wLogSlot:WORD; var pdwSwitchValue:DWORD): BOOL; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pApci8133GetVersion: TApci8133GetVersion;
	pApci8133Create: TApci8133Create;
	pApci8133Close: TApci8133Close;
	pApci8133GetResource: TApci8133GetResource;
	pApci8133OutPort: TApci8133OutPort;
	pApci8133GetLastError: TApci8133GetLastError;
	pApci8133GetSwitchValue: TApci8133GetSwitchValue;

function Apci8133wGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		apci8133.dll۰(۰ގʹװƂ)
// 		
// ߂l        True
//		s False
//============================================================================
function Apci8133wDllOpen: Boolean;
begin
	Result:=False;
	if hDLL=0 then begin
	   hDLL:=LoadLibrary(APCI8133_DLL_NAME);
	   if hDLL<>0 then begin
	      if Apci8133wGetDllExportFunc=True then Result:=True
	      else Apci8133wDllClose;	// DLL֐擾ɎŝDLLN[Y
           end;
	end;
end;
//============================================================================
// 		apci8133.dll۰(۰ގʹװƂ)
// 		
// ߂l        True
//		s False
//============================================================================
function Apci8133wDllClose: Boolean;
begin
	Result:=False;
	if hDLL<>0 then begin
           if True=FreeLibrary(hDLL) then begin
	      hDLL:=0;
	      Result:=True;
           end;
	end;
end;
//============================================================================
// 		aPCI-8133 DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion	 DLLްޮݔԍi[̈ւ߲
//		pdwDriverVersion ޲ײްްޮݔԍi[̈ւ߲
// ߂l        True
//		s False
//============================================================================
function Apci8133wGetVersion(var pdwDllVersion:DWord; var pdwDriverVersion:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
           Result:=pApci8133GetVersion(pdwDllVersion, pdwDriverVersion)
end;
//============================================================================
// 		aPCI-8133̔Cӂ޲̎gp錾
// 		pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l        True
//		s False
//============================================================================
function Apci8133wCreate(var pwLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
	   Result:=pApci8133Create(pwLogSlot)
end;
//============================================================================
// 		aPCI-8133̔Cӂ޲̎gpJ
// 		wLogSlot         ޲̘_ۯĔԍ
// ߂l        True
//		s False
//============================================================================
function Apci8133wClose(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
	   Result:=pApci8133Close(wLogSlot)
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSlot	ؿ擾޲̘_ۯĔԍ
//		pResInfo	ؿi[\߲̂
// ߂l        True
//		s False
//============================================================================
function Apci8133wGetResource(wLogSlot:Word; var pResInfo:TAPCI8133RESOURCE): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
	   Result:=pApci8133GetResource(wLogSlot, pResInfo)
end;
//============================================================================
// 		Cӂ߰Ăްo
// 		wLogSlot	o͂޲̘_ۯĔԍ
//		dwLogPort	o͂_߰
//		bOutValue       o͂ް
// ߂l        True
//		s False
//============================================================================
function Apci8133wOutPort(wLogSlot:Word; dwLogPort:DWord; bOutValue:Byte): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
	   Result:=pApci8133OutPort(wLogSlot, dwLogPort, bOutValue)
end;
//============================================================================
// 		aPCI-8133̴װ
// 		wLogSlot	װ޲̘_ۯĔԍ
// ߂l       װ
//============================================================================
function Apci8133wGetLastError(wLogSlot:Word): DWord;
begin
	if hDLL=0 then Result:=APCI8133_ERR_WRAPDLL
	else Result:=pApci8133GetLastError(wLogSlot)
end;
//============================================================================
// 		۰ذ̒l擾
// 		wLogSlot 	۰ذ̒l擾޲̘_ۯĔԍ
// 		pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l        True
//		s False
//============================================================================
function Apci8133wGetSwitchValue(wLogSlot:Word; var pdwSwitchValue:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
	   Result:=pApci8133GetSwitchValue(wLogSlot, pdwSwitchValue)
end;
//---------------------------------------------------------------------------
// 	        DLL߰Ċ֐ڽ̎擾
// 	        
// ߂l        True
//		s False
//---------------------------------------------------------------------------
function Apci8133wGetDllExportFunc: Boolean;
begin
	Result:=False;
	// Apci8133GetVersion ̱ڽ擾
	pApci8133GetVersion:=GetProcAddress(hDLL, 'Apci8133GetVersion');
	if @pApci8133GetVersion=nil then Exit;
	// Apci8133Create ̱ڽ擾
	pApci8133Create:=GetProcAddress(hDLL, 'Apci8133Create');
	if @pApci8133Create=nil then Exit;
	// Apci8133Close ̱ڽ擾
	pApci8133Close:=GetProcAddress(hDLL, 'Apci8133Close');
	if @pApci8133Close=nil then Exit;
	// Apci8133GetResource ̱ڽ擾
	pApci8133GetResource:=GetProcAddress(hDLL, 'Apci8133GetResource');
	if @pApci8133GetResource=nil then Exit;
	// Apci8133OutPort ̱ڽ擾
	pApci8133OutPort:=GetProcAddress(hDLL, 'Apci8133OutPort');
	if @pApci8133OutPort=nil then Exit;
	// Apci8133GetLastError ̱ڽ擾
	pApci8133GetLastError:=GetProcAddress(hDLL, 'Apci8133GetLastError');
	if @pApci8133GetLastError=nil then Exit;
	// Apci8133GetSwitchValue ̱ڽ擾
	pApci8133GetSwitchValue:=GetProcAddress(hDLL, 'Apci8133GetSwitchValue');
	if @pApci8133GetSwitchValue=nil then Exit;
	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result:=True;
end;

end.


